function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/*
 * Licensed to Elasticsearch B.V. under one or more contributor
 * license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright
 * ownership. Elasticsearch B.V. licenses this file to you under
 * the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
import { compact, flattenDeep, isString } from 'lodash';
var defaultTitle = [];
var titleSeparator = ' - ';
/** @internal */

export var DocTitleService = /*#__PURE__*/function () {
  function DocTitleService() {
    _classCallCheck(this, DocTitleService);

    _defineProperty(this, "document", {
      title: ''
    });

    _defineProperty(this, "baseTitle", '');
  }

  _createClass(DocTitleService, [{
    key: "start",
    value: function start(_ref) {
      var _this = this;

      var document = _ref.document;
      this.document = document;
      this.baseTitle = document.title;
      return {
        change: function change(title) {
          _this.applyTitle(title);
        },
        reset: function reset() {
          _this.applyTitle(defaultTitle);
        },
        __legacy: {
          setBaseTitle: function setBaseTitle(baseTitle) {
            _this.baseTitle = baseTitle;
          }
        }
      };
    }
  }, {
    key: "applyTitle",
    value: function applyTitle(title) {
      this.document.title = this.render(title);
    }
  }, {
    key: "render",
    value: function render(title) {
      var parts = [].concat(_toConsumableArray(isString(title) ? [title] : title), [this.baseTitle]); // ensuring compat with legacy that might be passing nested arrays

      return compact(flattenDeep(parts)).join(titleSeparator);
    }
  }]);

  return DocTitleService;
}();