function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

/*
 * Licensed to Elasticsearch B.V. under one or more contributor
 * license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright
 * ownership. Elasticsearch B.V. licenses this file to you under
 * the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
import React, { useMemo } from 'react';
import { EuiFormRow, EuiSelect } from '@elastic/eui';
var emptyValue = {
  text: '',
  value: 'EMPTY_VALUE',
  disabled: true,
  hidden: true
};

function SelectOption(_ref) {
  var disabled = _ref.disabled,
      helpText = _ref.helpText,
      id = _ref.id,
      label = _ref.label,
      labelAppend = _ref.labelAppend,
      options = _ref.options,
      paramName = _ref.paramName,
      value = _ref.value,
      setValue = _ref.setValue,
      dataTestSubj = _ref['data-test-subj'];
  var availableOptions = useMemo(function () {
    return [emptyValue].concat(_toConsumableArray(options));
  }, [options]);
  return /*#__PURE__*/React.createElement(EuiFormRow, {
    compressed: true,
    fullWidth: true,
    helpText: helpText,
    id: id,
    label: label,
    labelAppend: labelAppend
  }, /*#__PURE__*/React.createElement(EuiSelect, {
    compressed: true,
    disabled: disabled,
    options: availableOptions,
    value: value === undefined ? emptyValue.value : value,
    onChange: function onChange(ev) {
      return setValue(paramName, ev.target.value);
    },
    fullWidth: true,
    "data-test-subj": dataTestSubj
  }));
}

export { SelectOption };