/*
 * Licensed to Elasticsearch B.V. under one or more contributor
 * license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright
 * ownership. Elasticsearch B.V. licenses this file to you under
 * the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
import { useCallback } from 'react';
import { instance as registry } from '../../contexts/editor_context/editor_registry';
import { restoreRequestFromHistory } from './restore_request_from_history';
export var useRestoreRequestFromHistory = function useRestoreRequestFromHistory() {
  return useCallback(function (req) {
    var editor = registry.getInputEditor();
    restoreRequestFromHistory(editor, req);
  }, []);
};