function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/*
 * Licensed to Elasticsearch B.V. under one or more contributor
 * license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright
 * ownership. Elasticsearch B.V. licenses this file to you under
 * the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
import { i18n } from '@kbn/i18n';
import { FeatureCatalogueCategory } from '../../home/public';
export var ConsoleUIPlugin = /*#__PURE__*/function () {
  function ConsoleUIPlugin() {
    _classCallCheck(this, ConsoleUIPlugin);
  }

  _createClass(ConsoleUIPlugin, [{
    key: "setup",
    value: function setup(_ref, _ref2) {
      var notifications = _ref.notifications,
          getStartServices = _ref.getStartServices;
      var devTools = _ref2.devTools,
          home = _ref2.home,
          usageCollection = _ref2.usageCollection;
      home.featureCatalogue.register({
        id: 'console',
        title: i18n.translate('console.devToolsTitle', {
          defaultMessage: 'Console'
        }),
        description: i18n.translate('console.devToolsDescription', {
          defaultMessage: 'Skip cURL and use this JSON interface to work with your data directly.'
        }),
        icon: 'consoleApp',
        path: '/app/dev_tools#/console',
        showOnHomePage: true,
        category: FeatureCatalogueCategory.ADMIN
      });
      devTools.register({
        id: 'console',
        order: 1,
        title: i18n.translate('console.consoleDisplayName', {
          defaultMessage: 'Console'
        }),
        enableRouting: false,
        mount: function () {
          var _mount = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref3) {
            var element, _yield$getStartServic, _yield$getStartServic2, core, injectedMetadata, I18nContext, DOC_LINK_VERSION, _yield$import, renderApp, elasticsearchUrl;

            return regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    element = _ref3.element;
                    _context.next = 3;
                    return getStartServices();

                  case 3:
                    _yield$getStartServic = _context.sent;
                    _yield$getStartServic2 = _slicedToArray(_yield$getStartServic, 1);
                    core = _yield$getStartServic2[0];
                    injectedMetadata = core.injectedMetadata, I18nContext = core.i18n.Context, DOC_LINK_VERSION = core.docLinks.DOC_LINK_VERSION;
                    _context.next = 9;
                    return import('./application');

                  case 9:
                    _yield$import = _context.sent;
                    renderApp = _yield$import.renderApp;
                    elasticsearchUrl = injectedMetadata.getInjectedVar('elasticsearchUrl', 'http://localhost:9200');
                    return _context.abrupt("return", renderApp({
                      docLinkVersion: DOC_LINK_VERSION,
                      I18nContext: I18nContext,
                      notifications: notifications,
                      elasticsearchUrl: elasticsearchUrl,
                      usageCollection: usageCollection,
                      element: element
                    }));

                  case 13:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee);
          }));

          function mount(_x) {
            return _mount.apply(this, arguments);
          }

          return mount;
        }()
      });
    }
  }, {
    key: "start",
    value: function start() {}
  }]);

  return ConsoleUIPlugin;
}();