function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/*
 * Licensed to Elasticsearch B.V. under one or more contributor
 * license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright
 * ownership. Elasticsearch B.V. licenses this file to you under
 * the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
import React from 'react';
import { DashboardGrid } from '../grid';
import { context } from '../../../../../kibana_react/public';
export var DashboardViewport = /*#__PURE__*/function (_React$Component) {
  _inherits(DashboardViewport, _React$Component);

  var _super = _createSuper(DashboardViewport);

  function DashboardViewport(props) {
    var _this;

    _classCallCheck(this, DashboardViewport);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "context", void 0);

    _defineProperty(_assertThisInitialized(_this), "subscription", void 0);

    _defineProperty(_assertThisInitialized(_this), "mounted", false);

    _defineProperty(_assertThisInitialized(_this), "onExitFullScreenMode", function () {
      _this.props.container.updateInput({
        isFullScreenMode: false
      });
    });

    var _this$props$container = _this.props.container.getInput(),
        isFullScreenMode = _this$props$container.isFullScreenMode,
        panels = _this$props$container.panels,
        useMargins = _this$props$container.useMargins,
        title = _this$props$container.title,
        isEmbeddedExternally = _this$props$container.isEmbeddedExternally,
        isEmptyState = _this$props$container.isEmptyState;

    _this.state = {
      isFullScreenMode: isFullScreenMode,
      panels: panels,
      useMargins: useMargins,
      title: title,
      isEmbeddedExternally: isEmbeddedExternally,
      isEmptyState: isEmptyState
    };
    return _this;
  }

  _createClass(DashboardViewport, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      this.mounted = true;
      this.subscription = this.props.container.getInput$().subscribe(function () {
        var _this2$props$containe = _this2.props.container.getInput(),
            isFullScreenMode = _this2$props$containe.isFullScreenMode,
            useMargins = _this2$props$containe.useMargins,
            title = _this2$props$containe.title,
            description = _this2$props$containe.description,
            isEmbeddedExternally = _this2$props$containe.isEmbeddedExternally,
            isEmptyState = _this2$props$containe.isEmptyState;

        if (_this2.mounted) {
          _this2.setState({
            isFullScreenMode: isFullScreenMode,
            description: description,
            useMargins: useMargins,
            title: title,
            isEmbeddedExternally: isEmbeddedExternally,
            isEmptyState: isEmptyState
          });
        }
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.mounted = false;

      if (this.subscription) {
        this.subscription.unsubscribe();
      }
    }
  }, {
    key: "renderEmptyScreen",
    value: function renderEmptyScreen() {
      var renderEmpty = this.props.renderEmpty;
      var _this$state = this.state,
          isEmbeddedExternally = _this$state.isEmbeddedExternally,
          isFullScreenMode = _this$state.isFullScreenMode;
      return /*#__PURE__*/React.createElement("div", {
        className: "dshDashboardEmptyScreen"
      }, isFullScreenMode && /*#__PURE__*/React.createElement(this.context.services.ExitFullScreenButton, {
        onExitFullScreenMode: this.onExitFullScreenMode,
        toggleChrome: !isEmbeddedExternally
      }), renderEmpty && renderEmpty());
    }
  }, {
    key: "renderContainerScreen",
    value: function renderContainerScreen() {
      var _this$props = this.props,
          container = _this$props.container,
          PanelComponent = _this$props.PanelComponent;
      var _this$state2 = this.state,
          isEmbeddedExternally = _this$state2.isEmbeddedExternally,
          isFullScreenMode = _this$state2.isFullScreenMode,
          panels = _this$state2.panels,
          title = _this$state2.title,
          description = _this$state2.description,
          useMargins = _this$state2.useMargins;
      return /*#__PURE__*/React.createElement("div", {
        "data-shared-items-count": Object.values(panels).length,
        "data-shared-items-container": true,
        "data-title": title,
        "data-description": description,
        className: useMargins ? 'dshDashboardViewport-withMargins' : 'dshDashboardViewport'
      }, isFullScreenMode && /*#__PURE__*/React.createElement(this.context.services.ExitFullScreenButton, {
        onExitFullScreenMode: this.onExitFullScreenMode,
        toggleChrome: !isEmbeddedExternally
      }), /*#__PURE__*/React.createElement(DashboardGrid, {
        container: container,
        PanelComponent: PanelComponent
      }));
    }
  }, {
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement(React.Fragment, null, this.state.isEmptyState ? this.renderEmptyScreen() : null, this.renderContainerScreen());
    }
  }]);

  return DashboardViewport;
}(React.Component);

_defineProperty(DashboardViewport, "contextType", context);