function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

/*
 * Licensed to Elasticsearch B.V. under one or more contributor
 * license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright
 * ownership. Elasticsearch B.V. licenses this file to you under
 * the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
import { i18n } from '@kbn/i18n';
import { getIndexPatterns } from '../../services';
var name = 'indexPatternLoad';
export var indexPatternLoad = function indexPatternLoad() {
  return {
    name: name,
    type: 'index_pattern',
    inputTypes: ['null'],
    help: i18n.translate('data.functions.indexPatternLoad.help', {
      defaultMessage: 'Loads an index pattern'
    }),
    args: {
      id: {
        types: ['string'],
        required: true,
        help: i18n.translate('data.functions.indexPatternLoad.id.help', {
          defaultMessage: 'index pattern id to load'
        })
      }
    },
    fn: function fn(input, args) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var indexPatterns, indexPattern;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                indexPatterns = getIndexPatterns();
                _context.next = 3;
                return indexPatterns.get(args.id);

              case 3:
                indexPattern = _context.sent;
                return _context.abrupt("return", {
                  type: 'index_pattern',
                  value: indexPattern.toSpec()
                });

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))();
    }
  };
};