function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/*
 * Licensed to Elasticsearch B.V. under one or more contributor
 * license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright
 * ownership. Elasticsearch B.V. licenses this file to you under
 * the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
import { BehaviorSubject } from 'rxjs';
import { i18n } from '@kbn/i18n';
import { sortBy } from 'lodash';
import { AppNavLinkStatus, DEFAULT_APP_CATEGORIES } from '../../../core/public';
import { createDevToolApp } from './dev_tool';
import './index.scss';
export var DevToolsPlugin = /*#__PURE__*/function () {
  function DevToolsPlugin() {
    _classCallCheck(this, DevToolsPlugin);

    _defineProperty(this, "devTools", new Map());

    _defineProperty(this, "appStateUpdater", new BehaviorSubject(function () {
      return {};
    }));
  }

  _createClass(DevToolsPlugin, [{
    key: "getSortedDevTools",
    value: function getSortedDevTools() {
      return sortBy(_toConsumableArray(this.devTools.values()), 'order');
    }
  }, {
    key: "setup",
    value: function setup(coreSetup, _ref) {
      var _this = this;

      var kibanaLegacy = _ref.kibanaLegacy;
      var applicationSetup = coreSetup.application,
          getStartServices = coreSetup.getStartServices;
      applicationSetup.register({
        id: 'dev_tools',
        title: i18n.translate('devTools.devToolsTitle', {
          defaultMessage: 'Dev Tools'
        }),
        updater$: this.appStateUpdater,
        euiIconType: 'devToolsApp',
        order: 9010,
        category: DEFAULT_APP_CATEGORIES.management,
        mount: function () {
          var _mount = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(params) {
            var element, history, _yield$getStartServic, _yield$getStartServic2, core, application, chrome, _yield$import, renderApp;

            return regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    element = params.element, history = params.history;
                    element.classList.add('devAppWrapper');
                    _context.next = 4;
                    return getStartServices();

                  case 4:
                    _yield$getStartServic = _context.sent;
                    _yield$getStartServic2 = _slicedToArray(_yield$getStartServic, 1);
                    core = _yield$getStartServic2[0];
                    application = core.application, chrome = core.chrome;
                    _context.next = 10;
                    return import('./application');

                  case 10:
                    _yield$import = _context.sent;
                    renderApp = _yield$import.renderApp;
                    return _context.abrupt("return", renderApp(element, application, chrome, history, _this.getSortedDevTools()));

                  case 13:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee);
          }));

          function mount(_x) {
            return _mount.apply(this, arguments);
          }

          return mount;
        }()
      });
      kibanaLegacy.forwardApp('dev_tools', 'dev_tools');
      return {
        register: function register(devToolArgs) {
          if (_this.devTools.has(devToolArgs.id)) {
            throw new Error("Dev tool with id [".concat(devToolArgs.id, "] has already been registered. Use a unique id."));
          }

          var devTool = createDevToolApp(devToolArgs);

          _this.devTools.set(devTool.id, devTool);

          return devTool;
        }
      };
    }
  }, {
    key: "start",
    value: function start() {
      if (this.getSortedDevTools().length === 0) {
        this.appStateUpdater.next(function () {
          return {
            navLinkStatus: AppNavLinkStatus.hidden
          };
        });
      }
    }
  }, {
    key: "stop",
    value: function stop() {}
  }]);

  return DevToolsPlugin;
}();