function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/*
 * Licensed to Elasticsearch B.V. under one or more contributor
 * license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright
 * ownership. Elasticsearch B.V. licenses this file to you under
 * the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
export function getDefaultFieldFilter() {
  return {
    missing: true,
    type: 'any',
    name: '',
    aggregatable: null,
    searchable: null
  };
}
export function setFieldFilterProp(state, name, value) {
  var newState = _objectSpread({}, state);

  if (name === 'missing') {
    newState.missing = Boolean(value);
  } else if (name === 'aggregatable') {
    newState.aggregatable = typeof value !== 'boolean' ? null : value;
  } else if (name === 'searchable') {
    newState.searchable = typeof value !== 'boolean' ? null : value;
  } else if (name === 'name') {
    newState.name = String(value);
  } else if (name === 'type') {
    newState.type = String(value);
  }

  return newState;
}
export function isFieldFiltered(field, filterState, fieldCounts) {
  var matchFilter = filterState.type === 'any' || field.type === filterState.type;
  var isAggregatable = filterState.aggregatable === null || field.aggregatable === filterState.aggregatable;
  var isSearchable = filterState.searchable === null || field.searchable === filterState.searchable;
  var scriptedOrMissing = !filterState.missing || field.type === '_source' || field.scripted || fieldCounts[field.name] > 0;
  var matchName = !filterState.name || field.name.indexOf(filterState.name) !== -1;
  return matchFilter && isAggregatable && isSearchable && scriptedOrMissing && matchName;
}