function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/*
 * Licensed to Elasticsearch B.V. under one or more contributor
 * license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright
 * ownership. Elasticsearch B.V. licenses this file to you under
 * the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
import { isSavedObjectEmbeddableInput } from '.';
export var AttributeService = /*#__PURE__*/function () {
  function AttributeService(type, savedObjectsClient) {
    _classCallCheck(this, AttributeService);

    this.type = type;
    this.savedObjectsClient = savedObjectsClient;
  }

  _createClass(AttributeService, [{
    key: "unwrapAttributes",
    value: function () {
      var _unwrapAttributes = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(input) {
        var savedObject;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!isSavedObjectEmbeddableInput(input)) {
                  _context.next = 5;
                  break;
                }

                _context.next = 3;
                return this.savedObjectsClient.get(this.type, input.savedObjectId);

              case 3:
                savedObject = _context.sent;
                return _context.abrupt("return", savedObject.attributes);

              case 5:
                return _context.abrupt("return", input.attributes);

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function unwrapAttributes(_x) {
        return _unwrapAttributes.apply(this, arguments);
      }

      return unwrapAttributes;
    }()
  }, {
    key: "wrapAttributes",
    value: function () {
      var _wrapAttributes = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(newAttributes, useRefType, embeddable) {
        var savedObjectId, savedItem;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                savedObjectId = embeddable && isSavedObjectEmbeddableInput(embeddable.getInput()) ? embeddable.getInput().savedObjectId : undefined;

                if (!useRefType) {
                  _context2.next = 14;
                  break;
                }

                if (!savedObjectId) {
                  _context2.next = 8;
                  break;
                }

                _context2.next = 5;
                return this.savedObjectsClient.update(this.type, savedObjectId, newAttributes);

              case 5:
                return _context2.abrupt("return", {
                  savedObjectId: savedObjectId
                });

              case 8:
                _context2.next = 10;
                return this.savedObjectsClient.create(this.type, newAttributes);

              case 10:
                savedItem = _context2.sent;
                return _context2.abrupt("return", {
                  savedObjectId: savedItem.id
                });

              case 12:
                _context2.next = 15;
                break;

              case 14:
                return _context2.abrupt("return", {
                  attributes: newAttributes
                });

              case 15:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function wrapAttributes(_x2, _x3, _x4) {
        return _wrapAttributes.apply(this, arguments);
      }

      return wrapAttributes;
    }()
  }]);

  return AttributeService;
}();