function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/*
 * Licensed to Elasticsearch B.V. under one or more contributor
 * license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright
 * ownership. Elasticsearch B.V. licenses this file to you under
 * the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
import { EuiText, EuiIcon, EuiSpacer } from '@elastic/eui';
import React from 'react';
import ReactDOM from 'react-dom';
import { Markdown } from '../../../../kibana_react/public';
import { Embeddable } from './embeddable';
export var ERROR_EMBEDDABLE_TYPE = 'error';
export function isErrorEmbeddable(embeddable) {
  return embeddable.error !== undefined;
}
export var ErrorEmbeddable = /*#__PURE__*/function (_Embeddable) {
  _inherits(ErrorEmbeddable, _Embeddable);

  var _super = _createSuper(ErrorEmbeddable);

  function ErrorEmbeddable(error, input, parent) {
    var _this;

    _classCallCheck(this, ErrorEmbeddable);

    _this = _super.call(this, input, {}, parent);

    _defineProperty(_assertThisInitialized(_this), "type", ERROR_EMBEDDABLE_TYPE);

    _defineProperty(_assertThisInitialized(_this), "error", void 0);

    _defineProperty(_assertThisInitialized(_this), "dom", void 0);

    _this.error = error;
    return _this;
  }

  _createClass(ErrorEmbeddable, [{
    key: "reload",
    value: function reload() {}
  }, {
    key: "render",
    value: function render(dom) {
      var title = typeof this.error === 'string' ? this.error : this.error.message;
      this.dom = dom;
      ReactDOM.render(
      /*#__PURE__*/
      // @ts-ignore
      React.createElement("div", {
        className: "embPanel__error embPanel__content",
        "data-test-subj": "embeddableStackError"
      }, /*#__PURE__*/React.createElement(EuiText, {
        color: "subdued",
        size: "xs"
      }, /*#__PURE__*/React.createElement(EuiIcon, {
        type: "alert",
        color: "danger"
      }), /*#__PURE__*/React.createElement(EuiSpacer, {
        size: "s"
      }), /*#__PURE__*/React.createElement(Markdown, {
        markdown: title,
        openLinksInNewTab: true,
        "data-test-subj": "errorMessageMarkdown"
      }))), dom);
    }
  }, {
    key: "destroy",
    value: function destroy() {
      if (this.dom) {
        ReactDOM.unmountComponentAtNode(this.dom);
      }
    }
  }]);

  return ErrorEmbeddable;
}(Embeddable);