function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

/*
 * Licensed to Elasticsearch B.V. under one or more contributor
 * license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright
 * ownership. Elasticsearch B.V. licenses this file to you under
 * the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
import React from 'react';
import { toMountPoint } from '../../../../../../../kibana_react/public';
import { AddPanelFlyout } from './add_panel_flyout';
export function openAddPanelFlyout(_x) {
  return _openAddPanelFlyout.apply(this, arguments);
}

function _openAddPanelFlyout() {
  _openAddPanelFlyout = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(options) {
    var embeddable, getFactory, getAllFactories, overlays, notifications, SavedObjectFinder, flyoutSession;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            embeddable = options.embeddable, getFactory = options.getFactory, getAllFactories = options.getAllFactories, overlays = options.overlays, notifications = options.notifications, SavedObjectFinder = options.SavedObjectFinder;
            flyoutSession = overlays.openFlyout(toMountPoint( /*#__PURE__*/React.createElement(AddPanelFlyout, {
              container: embeddable,
              onClose: function onClose() {
                if (flyoutSession) {
                  flyoutSession.close();
                }
              },
              getFactory: getFactory,
              getAllFactories: getAllFactories,
              notifications: notifications,
              SavedObjectFinder: SavedObjectFinder
            })), {
              'data-test-subj': 'dashboardAddPanel',
              ownFocus: true
            });

          case 2:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _openAddPanelFlyout.apply(this, arguments);
}