function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/*
 * Licensed to Elasticsearch B.V. under one or more contributor
 * license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright
 * ownership. Elasticsearch B.V. licenses this file to you under
 * the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
import React from 'react';
import { i18n } from '@kbn/i18n';
import { toMountPoint } from '../../../../../../kibana_react/public';
import { ContactCardEmbeddable } from './contact_card_embeddable';
import { ContactCardInitializer } from './contact_card_initializer';
export var CONTACT_CARD_EMBEDDABLE = 'CONTACT_CARD_EMBEDDABLE';
export var ContactCardEmbeddableFactory = /*#__PURE__*/function () {
  function ContactCardEmbeddableFactory(execTrigger, overlays) {
    var _this = this;

    _classCallCheck(this, ContactCardEmbeddableFactory);

    this.execTrigger = execTrigger;
    this.overlays = overlays;

    _defineProperty(this, "type", CONTACT_CARD_EMBEDDABLE);

    _defineProperty(this, "getExplicitInput", function () {
      return new Promise(function (resolve) {
        var modalSession = _this.overlays.openModal(toMountPoint( /*#__PURE__*/React.createElement(ContactCardInitializer, {
          onCancel: function onCancel() {
            modalSession.close();
            resolve(undefined);
          },
          onCreate: function onCreate(input) {
            modalSession.close();
            resolve(input);
          }
        })), {
          'data-test-subj': 'createContactCardEmbeddable'
        });
      });
    });

    _defineProperty(this, "create", /*#__PURE__*/function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(initialInput, parent) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt("return", new ContactCardEmbeddable(initialInput, {
                  execAction: _this.execTrigger
                }, parent));

              case 1:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x, _x2) {
        return _ref.apply(this, arguments);
      };
    }());
  }

  _createClass(ContactCardEmbeddableFactory, [{
    key: "isEditable",
    value: function () {
      var _isEditable = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                return _context2.abrupt("return", true);

              case 1:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      function isEditable() {
        return _isEditable.apply(this, arguments);
      }

      return isEditable;
    }()
  }, {
    key: "getDisplayName",
    value: function getDisplayName() {
      return i18n.translate('embeddableApi.samples.contactCard.displayName', {
        defaultMessage: 'contact card'
      });
    }
  }]);

  return ContactCardEmbeddableFactory;
}();