function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

/*
 * Licensed to Elasticsearch B.V. under one or more contributor
 * license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright
 * ownership. Elasticsearch B.V. licenses this file to you under
 * the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
import React from 'react';
import { plugin as pluginInitializer } from '.';
/* eslint-disable */

import { coreMock } from '../../../core/public/mocks';
import { bfetchPluginMock } from '../../bfetch/public/mocks';
/* eslint-enable */

var createSetupContract = function createSetupContract() {
  var setupContract = {
    fork: jest.fn(),
    getFunction: jest.fn(),
    getFunctions: jest.fn(),
    getRenderer: jest.fn(),
    getRenderers: jest.fn(),
    getType: jest.fn(),
    getTypes: jest.fn(),
    registerFunction: jest.fn(),
    registerRenderer: jest.fn(),
    registerType: jest.fn(),
    run: jest.fn(),
    __LEGACY: {
      functions: {
        register: function register() {}
      },
      renderers: {
        register: function register() {}
      },
      types: {
        register: function register() {}
      },
      getExecutor: function getExecutor() {
        return {
          interpreter: {
            interpretAst: function () {}
          }
        };
      },
      loadLegacyServerFunctionWrappers: function loadLegacyServerFunctionWrappers() {
        return Promise.resolve();
      }
    }
  };
  return setupContract;
};

var createStartContract = function createStartContract() {
  return {
    execute: jest.fn(),
    ExpressionLoader: jest.fn(),
    ExpressionRenderHandler: jest.fn(),
    fork: jest.fn(),
    getFunction: jest.fn(),
    getFunctions: jest.fn(),
    getRenderer: jest.fn(),
    getRenderers: jest.fn(),
    getType: jest.fn(),
    getTypes: jest.fn(),
    loader: jest.fn(),
    ReactExpressionRenderer: jest.fn(function (props) {
      return /*#__PURE__*/React.createElement(React.Fragment, null);
    }),
    render: jest.fn(),
    run: jest.fn()
  };
};

var createPlugin = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
    var pluginInitializerContext, coreSetup, coreStart, plugin, setup;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            pluginInitializerContext = coreMock.createPluginInitializerContext();
            coreSetup = coreMock.createSetup();
            coreStart = coreMock.createStart();
            plugin = pluginInitializer(pluginInitializerContext);
            _context2.next = 6;
            return plugin.setup(coreSetup, {
              bfetch: bfetchPluginMock.createSetupContract()
            });

          case 6:
            setup = _context2.sent;
            return _context2.abrupt("return", {
              pluginInitializerContext: pluginInitializerContext,
              coreSetup: coreSetup,
              coreStart: coreStart,
              plugin: plugin,
              setup: setup,
              doStart: function () {
                var _doStart = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                  return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          _context.next = 2;
                          return plugin.start(coreStart, {
                            bfetch: bfetchPluginMock.createStartContract()
                          });

                        case 2:
                          return _context.abrupt("return", _context.sent);

                        case 3:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee);
                }));

                function doStart() {
                  return _doStart.apply(this, arguments);
                }

                return doStart;
              }()
            });

          case 8:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function createPlugin() {
    return _ref.apply(this, arguments);
  };
}();

export var expressionsPluginMock = {
  createSetupContract: createSetupContract,
  createStartContract: createStartContract,
  createPlugin: createPlugin
};