function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/*
 * Licensed to Elasticsearch B.V. under one or more contributor
 * license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright
 * ownership. Elasticsearch B.V. licenses this file to you under
 * the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
// @ts-ignore
import { euiColorAccent } from '@elastic/eui/dist/eui_theme_light.json';
import React, { Component, Fragment } from 'react';
import { EuiBadge, EuiButton, EuiContextMenuItem, EuiContextMenuPanel, EuiDescriptionList, EuiDescriptionListDescription, EuiDescriptionListTitle, EuiPopover } from '@elastic/eui';
import { FormattedMessage } from '@kbn/i18n/react';
export var CreateButton = /*#__PURE__*/function (_Component) {
  _inherits(CreateButton, _Component);

  var _super = _createSuper(CreateButton);

  function CreateButton() {
    var _this;

    _classCallCheck(this, CreateButton);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      isPopoverOpen: false
    });

    _defineProperty(_assertThisInitialized(_this), "togglePopover", function () {
      _this.setState({
        isPopoverOpen: !_this.state.isPopoverOpen
      });
    });

    _defineProperty(_assertThisInitialized(_this), "closePopover", function () {
      _this.setState({
        isPopoverOpen: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "renderBetaBadge", function () {
      return /*#__PURE__*/React.createElement(EuiBadge, {
        color: euiColorAccent
      }, /*#__PURE__*/React.createElement(FormattedMessage, {
        id: "indexPatternManagement.indexPatternList.createButton.betaLabel",
        defaultMessage: "Beta"
      }));
    });

    return _this;
  }

  _createClass(CreateButton, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          options = _this$props.options,
          children = _this$props.children;
      var isPopoverOpen = this.state.isPopoverOpen;

      if (!options || !options.length) {
        return null;
      }

      if (options.length === 1) {
        return /*#__PURE__*/React.createElement(EuiButton, {
          "data-test-subj": "createIndexPatternButton",
          fill: true,
          onClick: options[0].onClick,
          iconType: "plusInCircle"
        }, children);
      }

      var button = /*#__PURE__*/React.createElement(EuiButton, {
        "data-test-subj": "createIndexPatternButton",
        fill: true,
        size: "s",
        iconType: "arrowDown",
        iconSide: "right",
        onClick: this.togglePopover
      }, children);

      if (options.length > 1) {
        return /*#__PURE__*/React.createElement(EuiPopover, {
          id: "singlePanel",
          button: button,
          isOpen: isPopoverOpen,
          closePopover: this.closePopover,
          panelPaddingSize: "none",
          anchorPosition: "downLeft"
        }, /*#__PURE__*/React.createElement(EuiContextMenuPanel, {
          items: options.map(function (option) {
            return /*#__PURE__*/React.createElement(EuiContextMenuItem, {
              key: option.text,
              onClick: option.onClick,
              "data-test-subj": option.testSubj
            }, /*#__PURE__*/React.createElement(EuiDescriptionList, {
              style: {
                whiteSpace: 'nowrap'
              }
            }, /*#__PURE__*/React.createElement(EuiDescriptionListTitle, null, option.text, option.isBeta ? /*#__PURE__*/React.createElement(Fragment, null, " ", _this2.renderBetaBadge()) : null), /*#__PURE__*/React.createElement(EuiDescriptionListDescription, null, option.description)));
          })
        }));
      }
    }
  }]);

  return CreateButton;
}(Component);