function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/*
 * Licensed to Elasticsearch B.V. under one or more contributor
 * license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright
 * ownership. Elasticsearch B.V. licenses this file to you under
 * the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
import React, { Component } from 'react';
import { createSelector } from 'reselect';
import { Table } from './components/table';
import { getFieldFormat } from './lib';
export var IndexedFieldsTable = /*#__PURE__*/function (_Component) {
  _inherits(IndexedFieldsTable, _Component);

  var _super = _createSuper(IndexedFieldsTable);

  function IndexedFieldsTable(_props) {
    var _this;

    _classCallCheck(this, IndexedFieldsTable);

    _this = _super.call(this, _props);

    _defineProperty(_assertThisInitialized(_this), "getFilteredFields", createSelector(function (state) {
      return state.fields;
    }, function (state, props) {
      return props.fieldFilter;
    }, function (state, props) {
      return props.indexedFieldTypeFilter;
    }, function (fields, fieldFilter, indexedFieldTypeFilter) {
      if (fieldFilter) {
        var normalizedFieldFilter = fieldFilter.toLowerCase();
        fields = fields.filter(function (field) {
          return field.name.toLowerCase().includes(normalizedFieldFilter);
        });
      }

      if (indexedFieldTypeFilter) {
        fields = fields.filter(function (field) {
          return field.type === indexedFieldTypeFilter;
        });
      }

      return fields;
    }));

    _this.state = {
      fields: _this.mapFields(_this.props.fields)
    };
    return _this;
  }

  _createClass(IndexedFieldsTable, [{
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (nextProps.fields !== this.props.fields) {
        this.setState({
          fields: this.mapFields(nextProps.fields)
        });
      }
    }
  }, {
    key: "mapFields",
    value: function mapFields(fields) {
      var _this$props = this.props,
          indexPattern = _this$props.indexPattern,
          fieldWildcardMatcher = _this$props.fieldWildcardMatcher,
          helpers = _this$props.helpers;
      var sourceFilters = indexPattern.sourceFilters && indexPattern.sourceFilters.map(function (f) {
        return f.value;
      });
      var fieldWildcardMatch = fieldWildcardMatcher(sourceFilters || []);
      return fields && fields.map(function (field) {
        return _objectSpread(_objectSpread({}, field), {}, {
          displayName: field.displayName,
          indexPattern: field.indexPattern,
          format: getFieldFormat(indexPattern, field.name),
          excluded: fieldWildcardMatch ? fieldWildcardMatch(field.name) : false,
          info: helpers.getFieldInfo && helpers.getFieldInfo(indexPattern, field)
        });
      }) || [];
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var indexPattern = this.props.indexPattern;
      var fields = this.getFilteredFields(this.state, this.props);
      return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Table, {
        indexPattern: indexPattern,
        items: fields,
        editField: function editField(field) {
          return _this2.props.helpers.redirectToRoute(field);
        }
      }));
    }
  }]);

  return IndexedFieldsTable;
}(Component);