function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/*
 * Licensed to Elasticsearch B.V. under one or more contributor
 * license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright
 * ownership. Elasticsearch B.V. licenses this file to you under
 * the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
import React, { PureComponent } from 'react';
import { get } from 'lodash';
import { i18n } from '@kbn/i18n';
import { EuiInMemoryTable } from '@elastic/eui';
export var Table = /*#__PURE__*/function (_PureComponent) {
  _inherits(Table, _PureComponent);

  var _super = _createSuper(Table);

  function Table() {
    var _this;

    _classCallCheck(this, Table);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "renderFormatCell", function (value) {
      var indexPattern = _this.props.indexPattern;
      var title = get(indexPattern, ['fieldFormatMap', value, 'type', 'title'], '');
      return /*#__PURE__*/React.createElement("span", null, title);
    });

    return _this;
  }

  _createClass(Table, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          items = _this$props.items,
          editField = _this$props.editField,
          deleteField = _this$props.deleteField;
      var columns = [{
        field: 'displayName',
        name: i18n.translate('indexPatternManagement.editIndexPattern.scripted.table.nameHeader', {
          defaultMessage: 'Name'
        }),
        description: i18n.translate('indexPatternManagement.editIndexPattern.scripted.table.nameDescription', {
          defaultMessage: 'Name of the field'
        }),
        dataType: 'string',
        sortable: true,
        width: '38%'
      }, {
        field: 'lang',
        name: i18n.translate('indexPatternManagement.editIndexPattern.scripted.table.langHeader', {
          defaultMessage: 'Lang'
        }),
        description: i18n.translate('indexPatternManagement.editIndexPattern.scripted.table.langDescription', {
          defaultMessage: 'Language used for the field'
        }),
        dataType: 'string',
        sortable: true,
        'data-test-subj': 'scriptedFieldLang'
      }, {
        field: 'script',
        name: i18n.translate('indexPatternManagement.editIndexPattern.scripted.table.scriptHeader', {
          defaultMessage: 'Script'
        }),
        description: i18n.translate('indexPatternManagement.editIndexPattern.scripted.table.scriptDescription', {
          defaultMessage: 'Script for the field'
        }),
        dataType: 'string',
        sortable: true
      }, {
        field: 'name',
        name: i18n.translate('indexPatternManagement.editIndexPattern.scripted.table.formatHeader', {
          defaultMessage: 'Format'
        }),
        description: i18n.translate('indexPatternManagement.editIndexPattern.scripted.table.formatDescription', {
          defaultMessage: 'Format used for the field'
        }),
        render: this.renderFormatCell,
        sortable: false
      }, {
        name: '',
        actions: [{
          type: 'icon',
          name: i18n.translate('indexPatternManagement.editIndexPattern.scripted.table.editHeader', {
            defaultMessage: 'Edit'
          }),
          description: i18n.translate('indexPatternManagement.editIndexPattern.scripted.table.editDescription', {
            defaultMessage: 'Edit this field'
          }),
          icon: 'pencil',
          onClick: editField
        }, {
          type: 'icon',
          name: i18n.translate('indexPatternManagement.editIndexPattern.scripted.table.deleteHeader', {
            defaultMessage: 'Delete'
          }),
          description: i18n.translate('indexPatternManagement.editIndexPattern.scripted.table.deleteDescription', {
            defaultMessage: 'Delete this field'
          }),
          icon: 'trash',
          color: 'danger',
          onClick: deleteField
        }],
        width: '40px'
      }];
      var pagination = {
        initialPageSize: 10,
        pageSizeOptions: [5, 10, 25, 50]
      };
      return /*#__PURE__*/React.createElement(EuiInMemoryTable, {
        items: items,
        columns: columns,
        pagination: pagination,
        sorting: true
      });
    }
  }]);

  return Table;
}(PureComponent);