function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/*
 * Licensed to Elasticsearch B.V. under one or more contributor
 * license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright
 * ownership. Elasticsearch B.V. licenses this file to you under
 * the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
import './samples.scss';
import React, { PureComponent } from 'react';
import { EuiBasicTable, EuiFormRow } from '@elastic/eui';
import { i18n } from '@kbn/i18n';
import { FormattedMessage } from '@kbn/i18n/react';
export var FormatEditorSamples = /*#__PURE__*/function (_PureComponent) {
  _inherits(FormatEditorSamples, _PureComponent);

  var _super = _createSuper(FormatEditorSamples);

  function FormatEditorSamples() {
    _classCallCheck(this, FormatEditorSamples);

    return _super.apply(this, arguments);
  }

  _createClass(FormatEditorSamples, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          samples = _this$props.samples,
          sampleType = _this$props.sampleType;
      var columns = [{
        field: 'input',
        name: i18n.translate('indexPatternManagement.samples.inputHeader', {
          defaultMessage: 'Input'
        }),
        render: function render(input) {
          return _typeof(input) === 'object' ? JSON.stringify(input) : input;
        }
      }, {
        field: 'output',
        name: i18n.translate('indexPatternManagement.samples.outputHeader', {
          defaultMessage: 'Output'
        }),
        render: function render(output) {
          return sampleType === 'html' ? /*#__PURE__*/React.createElement("div", {
            /*
             * Justification for dangerouslySetInnerHTML:
             * Sample output may contain HTML tags, like URL image/audio format.
             */
            dangerouslySetInnerHTML: {
              __html: output
            } // eslint-disable-line react/no-danger

          }) : /*#__PURE__*/React.createElement("div", null, output);
        }
      }];
      return samples.length ? /*#__PURE__*/React.createElement(EuiFormRow, {
        label: /*#__PURE__*/React.createElement(FormattedMessage, {
          id: "indexPatternManagement.samplesHeader",
          defaultMessage: "Samples"
        })
      }, /*#__PURE__*/React.createElement(EuiBasicTable, {
        className: "kbnFieldFormatEditor__samples",
        compressed: true,
        items: samples,
        columns: columns
      })) : null;
    }
  }]);

  return FormatEditorSamples;
}(PureComponent);

_defineProperty(FormatEditorSamples, "defaultProps", {
  sampleType: 'text'
});