function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/*
 * Licensed to Elasticsearch B.V. under one or more contributor
 * license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright
 * ownership. Elasticsearch B.V. licenses this file to you under
 * the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
import _ from 'lodash';
import React, { Component } from 'react';
import { injectI18n, FormattedMessage } from '@kbn/i18n/react';
import { EuiFormRow, EuiComboBox } from '@elastic/eui';

var FieldSelectUi = /*#__PURE__*/function (_Component) {
  _inherits(FieldSelectUi, _Component);

  var _super = _createSuper(FieldSelectUi);

  function FieldSelectUi(props) {
    var _this;

    _classCallCheck(this, FieldSelectUi);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "hasUnmounted", void 0);

    _defineProperty(_assertThisInitialized(_this), "loadFields", function (indexPatternId) {
      _this.setState({
        isLoading: true,
        fields: [],
        indexPatternId: indexPatternId
      }, _this.debouncedLoad.bind(null, indexPatternId));
    });

    _defineProperty(_assertThisInitialized(_this), "debouncedLoad", _.debounce( /*#__PURE__*/function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(indexPatternId) {
        var _this$props$filterFie;

        var indexPattern, fieldsByTypeMap, fields;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(!indexPatternId || indexPatternId.length === 0)) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt("return");

              case 2:
                _context.prev = 2;
                _context.next = 5;
                return _this.props.getIndexPattern(indexPatternId);

              case 5:
                indexPattern = _context.sent;
                _context.next = 11;
                break;

              case 8:
                _context.prev = 8;
                _context.t0 = _context["catch"](2);
                return _context.abrupt("return");

              case 11:
                if (!_this.hasUnmounted) {
                  _context.next = 13;
                  break;
                }

                return _context.abrupt("return");

              case 13:
                if (!(indexPattern.id !== _this.state.indexPatternId)) {
                  _context.next = 15;
                  break;
                }

                return _context.abrupt("return");

              case 15:
                fieldsByTypeMap = new Map();
                fields = [];
                indexPattern.fields.filter((_this$props$filterFie = _this.props.filterField) !== null && _this$props$filterFie !== void 0 ? _this$props$filterFie : function () {
                  return true;
                }).forEach(function (field) {
                  var _fieldsByTypeMap$get;

                  var fieldsList = (_fieldsByTypeMap$get = fieldsByTypeMap.get(field.type)) !== null && _fieldsByTypeMap$get !== void 0 ? _fieldsByTypeMap$get : [];
                  fieldsList.push(field.name);
                  fieldsByTypeMap.set(field.type, fieldsList);
                });
                fieldsByTypeMap.forEach(function (fieldsList, fieldType) {
                  fields.push({
                    label: fieldType,
                    options: fieldsList.sort().map(function (fieldName) {
                      return {
                        value: fieldName,
                        label: fieldName
                      };
                    })
                  });
                });
                fields.sort(function (a, b) {
                  if (a.label < b.label) return -1;
                  if (a.label > b.label) return 1;
                  return 0;
                });

                _this.setState({
                  isLoading: false,
                  fields: fields
                });

              case 21:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[2, 8]]);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }(), 300));

    _defineProperty(_assertThisInitialized(_this), "onChange", function (selectedOptions) {
      _this.props.onChange(_.get(selectedOptions, '0.value'));
    });

    _this.hasUnmounted = false;
    _this.state = {
      isLoading: false,
      fields: [],
      indexPatternId: props.indexPatternId
    };
    return _this;
  }

  _createClass(FieldSelectUi, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.hasUnmounted = true;
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.loadFields(this.state.indexPatternId);
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (this.props.indexPatternId !== nextProps.indexPatternId) {
        var _nextProps$indexPatte;

        this.loadFields((_nextProps$indexPatte = nextProps.indexPatternId) !== null && _nextProps$indexPatte !== void 0 ? _nextProps$indexPatte : '');
      }
    }
  }, {
    key: "render",
    value: function render() {
      if (!this.props.indexPatternId || this.props.indexPatternId.trim().length === 0) {
        return null;
      }

      var selectId = "fieldSelect-".concat(this.props.controlIndex);
      var selectedOptions = [];
      var intl = this.props.intl;

      if (this.props.fieldName) {
        selectedOptions.push({
          value: this.props.fieldName,
          label: this.props.fieldName
        });
      }

      return /*#__PURE__*/React.createElement(EuiFormRow, {
        id: selectId,
        label: /*#__PURE__*/React.createElement(FormattedMessage, {
          id: "inputControl.editor.fieldSelect.fieldLabel",
          defaultMessage: "Field"
        })
      }, /*#__PURE__*/React.createElement(EuiComboBox, {
        placeholder: intl.formatMessage({
          id: 'inputControl.editor.fieldSelect.selectFieldPlaceholder',
          defaultMessage: 'Select field...'
        }),
        singleSelection: true,
        isLoading: this.state.isLoading,
        options: this.state.fields,
        selectedOptions: selectedOptions,
        onChange: this.onChange,
        "data-test-subj": selectId
      }));
    }
  }]);

  return FieldSelectUi;
}(Component);

export var FieldSelect = injectI18n(FieldSelectUi);