function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/*
 * Licensed to Elasticsearch B.V. under one or more contributor
 * license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright
 * ownership. Elasticsearch B.V. licenses this file to you under
 * the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
import React, { useState, Fragment, useEffect } from 'react';
import { EuiHeaderSectionItemButton, EuiIcon, EuiNotificationBadge } from '@elastic/eui';
import { NewsfeedFlyout } from './flyout_list';
export var NewsfeedContext = React.createContext({});
export var NewsfeedNavButton = function NewsfeedNavButton(_ref) {
  var apiFetchResult = _ref.apiFetchResult;

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      showBadge = _useState2[0],
      setShowBadge = _useState2[1];

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      flyoutVisible = _useState4[0],
      setFlyoutVisible = _useState4[1];

  var _useState5 = useState(null),
      _useState6 = _slicedToArray(_useState5, 2),
      newsFetchResult = _useState6[0],
      setNewsFetchResult = _useState6[1];

  useEffect(function () {
    function handleStatusChange(fetchResult) {
      if (fetchResult) {
        setShowBadge(fetchResult.hasNew);
      }

      setNewsFetchResult(fetchResult);
    }

    var subscription = apiFetchResult.subscribe(function (res) {
      return handleStatusChange(res);
    });
    return function () {
      return subscription.unsubscribe();
    };
  }, [apiFetchResult]);

  function showFlyout() {
    setShowBadge(false);
    setFlyoutVisible(!flyoutVisible);
  }

  return /*#__PURE__*/React.createElement(NewsfeedContext.Provider, {
    value: {
      setFlyoutVisible: setFlyoutVisible,
      newsFetchResult: newsFetchResult
    }
  }, /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement(EuiHeaderSectionItemButton, {
    "data-test-subj": "newsfeed",
    "aria-controls": "keyPadMenu",
    "aria-expanded": flyoutVisible,
    "aria-haspopup": "true",
    "aria-label": "Newsfeed\xA0menu",
    onClick: showFlyout
  }, /*#__PURE__*/React.createElement(EuiIcon, {
    type: "email",
    size: "m"
  }), showBadge ? /*#__PURE__*/React.createElement(EuiNotificationBadge, {
    className: "euiHeaderNotification",
    "data-test-subj": "showBadgeNews"
  }, "\u25AA") : null), flyoutVisible ? /*#__PURE__*/React.createElement(NewsfeedFlyout, null) : null));
};