function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

/*
 * Licensed to Elasticsearch B.V. under one or more contributor
 * license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright
 * ownership. Elasticsearch B.V. licenses this file to you under
 * the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
import { i18n } from '@kbn/i18n';
import { cloneDeep } from 'lodash';
import { injectSearchSourceReferences } from '../../../data/public';

function getSavedObject(_x, _x2) {
  return _getSavedObject.apply(this, arguments);
}

function _getSavedObject() {
  _getSavedObject = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(doc, services) {
    var service, obj;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            service = services.find(function (s) {
              return s.type === doc._type;
            });

            if (service) {
              _context.next = 3;
              break;
            }

            return _context.abrupt("return");

          case 3:
            _context.next = 5;
            return service.get();

          case 5:
            obj = _context.sent;
            obj.id = doc._id;
            obj.migrationVersion = doc._migrationVersion;
            return _context.abrupt("return", obj);

          case 9:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _getSavedObject.apply(this, arguments);
}

function addJsonFieldToIndexPattern(target, sourceString, fieldName, indexName) {
  if (sourceString) {
    try {
      target[fieldName] = JSON.parse(sourceString);
    } catch (error) {
      throw new Error(i18n.translate('savedObjectsManagement.parsingFieldErrorMessage', {
        defaultMessage: 'Error encountered parsing {fieldName} for index pattern {indexName}: {errorMessage}',
        values: {
          fieldName: fieldName,
          indexName: indexName,
          errorMessage: error.message
        }
      }));
    }
  }
}

function importIndexPattern(_x3, _x4, _x5, _x6) {
  return _importIndexPattern.apply(this, arguments);
}

function _importIndexPattern() {
  _importIndexPattern = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(doc, indexPatterns, overwriteAll, openConfirm) {
    var emptyPattern, _doc$_source, title, timeFieldName, fields, fieldFormatMap, sourceFilters, type, typeMeta, importedIndexPattern, newId, isConfirmed;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return indexPatterns.make();

          case 2:
            emptyPattern = _context2.sent;
            _doc$_source = doc._source, title = _doc$_source.title, timeFieldName = _doc$_source.timeFieldName, fields = _doc$_source.fields, fieldFormatMap = _doc$_source.fieldFormatMap, sourceFilters = _doc$_source.sourceFilters, type = _doc$_source.type, typeMeta = _doc$_source.typeMeta;
            importedIndexPattern = {
              id: doc._id,
              title: title,
              timeFieldName: timeFieldName
            };

            if (type) {
              importedIndexPattern.type = type;
            }

            addJsonFieldToIndexPattern(importedIndexPattern, fields, 'fields', title);
            addJsonFieldToIndexPattern(importedIndexPattern, fieldFormatMap, 'fieldFormatMap', title);
            addJsonFieldToIndexPattern(importedIndexPattern, sourceFilters, 'sourceFilters', title);
            addJsonFieldToIndexPattern(importedIndexPattern, typeMeta, 'typeMeta', title);
            Object.assign(emptyPattern, importedIndexPattern);
            _context2.next = 13;
            return emptyPattern.create(overwriteAll);

          case 13:
            newId = _context2.sent;

            if (newId) {
              _context2.next = 25;
              break;
            }

            _context2.next = 17;
            return openConfirm(i18n.translate('savedObjectsManagement.indexPattern.confirmOverwriteLabel', {
              values: {
                title: title
              },
              defaultMessage: "Are you sure you want to overwrite '{title}'?"
            }), {
              title: i18n.translate('savedObjectsManagement.indexPattern.confirmOverwriteTitle', {
                defaultMessage: 'Overwrite {type}?',
                values: {
                  type: type
                }
              }),
              confirmButtonText: i18n.translate('savedObjectsManagement.indexPattern.confirmOverwriteButton', {
                defaultMessage: 'Overwrite'
              })
            });

          case 17:
            isConfirmed = _context2.sent;

            if (!isConfirmed) {
              _context2.next = 24;
              break;
            }

            _context2.next = 21;
            return emptyPattern.create(true);

          case 21:
            newId = _context2.sent;
            _context2.next = 25;
            break;

          case 24:
            return _context2.abrupt("return");

          case 25:
            indexPatterns.clearCache(newId);
            return _context2.abrupt("return", newId);

          case 27:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _importIndexPattern.apply(this, arguments);
}

function importDocument(_x7, _x8, _x9) {
  return _importDocument.apply(this, arguments);
}

function _importDocument() {
  _importDocument = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(obj, doc, overwriteAll) {
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return obj.applyESResp(_objectSpread({
              references: doc._references || []
            }, cloneDeep(doc)));

          case 2:
            _context3.next = 4;
            return obj.save({
              confirmOverwrite: !overwriteAll
            });

          case 4:
            return _context3.abrupt("return", _context3.sent);

          case 5:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _importDocument.apply(this, arguments);
}

function groupByType(docs) {
  var defaultDocTypes = {
    searches: [],
    indexPatterns: [],
    other: []
  };
  return docs.reduce(function (types, doc) {
    switch (doc._type) {
      case 'search':
        types.searches.push(doc);
        break;

      case 'index-pattern':
        types.indexPatterns.push(doc);
        break;

      default:
        types.other.push(doc);
    }

    return types;
  }, defaultDocTypes);
}

export function resolveIndexPatternConflicts(_x10, _x11, _x12, _x13) {
  return _resolveIndexPatternConflicts.apply(this, arguments);
}

function _resolveIndexPatternConflicts() {
  _resolveIndexPatternConflicts = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(resolutions, conflictedIndexPatterns, overwriteAll, dependencies) {
    var importCount, _iterator, _step, _loop, _ret;

    return regeneratorRuntime.wrap(function _callee4$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            importCount = 0;
            _iterator = _createForOfIteratorHelper(conflictedIndexPatterns);
            _context5.prev = 2;
            _loop = /*#__PURE__*/regeneratorRuntime.mark(function _loop() {
              var _doc$_source$kibanaSa;

              var _step$value, obj, doc, serializedSearchSource, oldIndexId, allResolved, inlineResolution, filter, replacedReferences, serializedSearchSourceWithInjectedReferences;

              return regeneratorRuntime.wrap(function _loop$(_context4) {
                while (1) {
                  switch (_context4.prev = _context4.next) {
                    case 0:
                      _step$value = _step.value, obj = _step$value.obj, doc = _step$value.doc;
                      serializedSearchSource = JSON.parse(((_doc$_source$kibanaSa = doc._source.kibanaSavedObjectMeta) === null || _doc$_source$kibanaSa === void 0 ? void 0 : _doc$_source$kibanaSa.searchSourceJSON) || '{}');
                      oldIndexId = serializedSearchSource.index;
                      allResolved = true;
                      inlineResolution = resolutions.find(function (_ref) {
                        var oldId = _ref.oldId;
                        return oldId === oldIndexId;
                      });

                      if (inlineResolution) {
                        serializedSearchSource.index = inlineResolution.newId;
                      } else {
                        allResolved = false;
                      } // Resolve filter index reference:


                      filter = (serializedSearchSource.filter || []).map(function (f) {
                        if (!(f.meta && f.meta.index)) {
                          return f;
                        }

                        var resolution = resolutions.find(function (_ref2) {
                          var oldId = _ref2.oldId;
                          return oldId === f.meta.index;
                        });
                        return resolution ? _objectSpread(_objectSpread({}, f), {
                          meta: _objectSpread(_objectSpread({}, f.meta), {}, {
                            index: resolution.newId
                          })
                        }) : f;
                      });

                      if (filter.length > 0) {
                        serializedSearchSource.filter = filter;
                      }

                      replacedReferences = (doc._references || []).map(function (reference) {
                        var resolution = resolutions.find(function (_ref3) {
                          var oldId = _ref3.oldId;
                          return oldId === reference.id;
                        });

                        if (resolution) {
                          return _objectSpread(_objectSpread({}, reference), {}, {
                            id: resolution.newId
                          });
                        } else {
                          allResolved = false;
                        }

                        return reference;
                      });
                      serializedSearchSourceWithInjectedReferences = injectSearchSourceReferences(serializedSearchSource, replacedReferences);

                      if (allResolved) {
                        _context4.next = 12;
                        break;
                      }

                      return _context4.abrupt("return", "continue");

                    case 12:
                      _context4.next = 14;
                      return dependencies.search.searchSource.create(serializedSearchSourceWithInjectedReferences);

                    case 14:
                      obj.searchSource = _context4.sent;
                      _context4.next = 17;
                      return saveObject(obj, overwriteAll);

                    case 17:
                      if (!_context4.sent) {
                        _context4.next = 19;
                        break;
                      }

                      importCount++;

                    case 19:
                    case "end":
                      return _context4.stop();
                  }
                }
              }, _loop);
            });

            _iterator.s();

          case 5:
            if ((_step = _iterator.n()).done) {
              _context5.next = 12;
              break;
            }

            return _context5.delegateYield(_loop(), "t0", 7);

          case 7:
            _ret = _context5.t0;

            if (!(_ret === "continue")) {
              _context5.next = 10;
              break;
            }

            return _context5.abrupt("continue", 10);

          case 10:
            _context5.next = 5;
            break;

          case 12:
            _context5.next = 17;
            break;

          case 14:
            _context5.prev = 14;
            _context5.t1 = _context5["catch"](2);

            _iterator.e(_context5.t1);

          case 17:
            _context5.prev = 17;

            _iterator.f();

            return _context5.finish(17);

          case 20:
            return _context5.abrupt("return", importCount);

          case 21:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee4, null, [[2, 14, 17, 20]]);
  }));
  return _resolveIndexPatternConflicts.apply(this, arguments);
}

export function saveObjects(_x14, _x15) {
  return _saveObjects.apply(this, arguments);
}

function _saveObjects() {
  _saveObjects = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(objs, overwriteAll) {
    var importCount, _iterator2, _step2, obj;

    return regeneratorRuntime.wrap(function _callee5$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            importCount = 0;
            _iterator2 = _createForOfIteratorHelper(objs);
            _context6.prev = 2;

            _iterator2.s();

          case 4:
            if ((_step2 = _iterator2.n()).done) {
              _context6.next = 12;
              break;
            }

            obj = _step2.value;
            _context6.next = 8;
            return saveObject(obj, overwriteAll);

          case 8:
            if (!_context6.sent) {
              _context6.next = 10;
              break;
            }

            importCount++;

          case 10:
            _context6.next = 4;
            break;

          case 12:
            _context6.next = 17;
            break;

          case 14:
            _context6.prev = 14;
            _context6.t0 = _context6["catch"](2);

            _iterator2.e(_context6.t0);

          case 17:
            _context6.prev = 17;

            _iterator2.f();

            return _context6.finish(17);

          case 20:
            return _context6.abrupt("return", importCount);

          case 21:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee5, null, [[2, 14, 17, 20]]);
  }));
  return _saveObjects.apply(this, arguments);
}

export function saveObject(_x16, _x17) {
  return _saveObject.apply(this, arguments);
}

function _saveObject() {
  _saveObject = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(obj, overwriteAll) {
    return regeneratorRuntime.wrap(function _callee6$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            _context7.next = 2;
            return obj.save({
              confirmOverwrite: !overwriteAll
            });

          case 2:
            return _context7.abrupt("return", _context7.sent);

          case 3:
          case "end":
            return _context7.stop();
        }
      }
    }, _callee6);
  }));
  return _saveObject.apply(this, arguments);
}

export function resolveSavedSearches(_x18, _x19, _x20, _x21) {
  return _resolveSavedSearches.apply(this, arguments);
}

function _resolveSavedSearches() {
  _resolveSavedSearches = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(savedSearches, services, indexPatterns, overwriteAll) {
    var importCount, _iterator3, _step3, searchDoc, obj;

    return regeneratorRuntime.wrap(function _callee7$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            importCount = 0;
            _iterator3 = _createForOfIteratorHelper(savedSearches);
            _context8.prev = 2;

            _iterator3.s();

          case 4:
            if ((_step3 = _iterator3.n()).done) {
              _context8.next = 17;
              break;
            }

            searchDoc = _step3.value;
            _context8.next = 8;
            return getSavedObject(searchDoc, services);

          case 8:
            obj = _context8.sent;

            if (obj) {
              _context8.next = 11;
              break;
            }

            return _context8.abrupt("continue", 15);

          case 11:
            _context8.next = 13;
            return importDocument(obj, searchDoc, overwriteAll);

          case 13:
            if (!_context8.sent) {
              _context8.next = 15;
              break;
            }

            importCount++;

          case 15:
            _context8.next = 4;
            break;

          case 17:
            _context8.next = 22;
            break;

          case 19:
            _context8.prev = 19;
            _context8.t0 = _context8["catch"](2);

            _iterator3.e(_context8.t0);

          case 22:
            _context8.prev = 22;

            _iterator3.f();

            return _context8.finish(22);

          case 25:
            return _context8.abrupt("return", importCount);

          case 26:
          case "end":
            return _context8.stop();
        }
      }
    }, _callee7, null, [[2, 19, 22, 25]]);
  }));
  return _resolveSavedSearches.apply(this, arguments);
}

export function resolveSavedObjects(_x22, _x23, _x24, _x25, _x26) {
  return _resolveSavedObjects.apply(this, arguments);
}

function _resolveSavedObjects() {
  _resolveSavedObjects = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(savedObjects, overwriteAll, services, indexPatterns, confirmModalPromise) {
    var docTypes, importedObjectCount, failedImports, _iterator4, _step4, indexPatternDoc, importedIndexPatternId, conflictedSearchDocs, conflictedIndexPatterns, conflictedSavedObjectsLinkedToSavedSearches, _iterator5, _step5, searchDoc, obj, _iterator6, _step6, otherDoc, _obj, isIndexPatternNotFound;

    return regeneratorRuntime.wrap(function _callee8$(_context9) {
      while (1) {
        switch (_context9.prev = _context9.next) {
          case 0:
            docTypes = groupByType(savedObjects); // Keep track of how many we actually import because the user
            // can cancel an override

            importedObjectCount = 0;
            failedImports = []; // Start with the index patterns since everything is dependent on them
            // As the confirmation opens a modal, and as we only allow one modal at a time
            // (opening a new one close the previous with a rejection)
            // we can't do that in parallel

            _iterator4 = _createForOfIteratorHelper(docTypes.indexPatterns);
            _context9.prev = 4;

            _iterator4.s();

          case 6:
            if ((_step4 = _iterator4.n()).done) {
              _context9.next = 20;
              break;
            }

            indexPatternDoc = _step4.value;
            _context9.prev = 8;
            _context9.next = 11;
            return importIndexPattern(indexPatternDoc, indexPatterns, overwriteAll, confirmModalPromise);

          case 11:
            importedIndexPatternId = _context9.sent;

            if (importedIndexPatternId) {
              importedObjectCount++;
            }

            _context9.next = 18;
            break;

          case 15:
            _context9.prev = 15;
            _context9.t0 = _context9["catch"](8);
            failedImports.push({
              obj: indexPatternDoc,
              error: _context9.t0
            });

          case 18:
            _context9.next = 6;
            break;

          case 20:
            _context9.next = 25;
            break;

          case 22:
            _context9.prev = 22;
            _context9.t1 = _context9["catch"](4);

            _iterator4.e(_context9.t1);

          case 25:
            _context9.prev = 25;

            _iterator4.f();

            return _context9.finish(25);

          case 28:
            // We want to do the same for saved searches, but we want to keep them separate because they need
            // to be applied _first_ because other saved objects can be dependent on those saved searches existing
            conflictedSearchDocs = []; // Keep a record of the index patterns assigned to our imported saved objects that do not
            // exist. We will provide a way for the user to manually select a new index pattern for those
            // saved objects.

            conflictedIndexPatterns = []; // Keep a record of any objects which fail to import for unknown reasons.
            // It's possible to have saved objects that link to saved searches which then link to index patterns
            // and those could error out, but the error comes as an index pattern not found error. We can't resolve
            // those the same as way as normal index pattern not found errors, but when those are fixed, it's very
            // likely that these saved objects will work once resaved so keep them around to resave them.

            conflictedSavedObjectsLinkedToSavedSearches = [];
            _iterator5 = _createForOfIteratorHelper(docTypes.searches);
            _context9.prev = 32;

            _iterator5.s();

          case 34:
            if ((_step5 = _iterator5.n()).done) {
              _context9.next = 51;
              break;
            }

            searchDoc = _step5.value;
            _context9.next = 38;
            return getSavedObject(searchDoc, services);

          case 38:
            obj = _context9.sent;
            _context9.prev = 39;
            _context9.next = 42;
            return importDocument(obj, searchDoc, overwriteAll);

          case 42:
            if (!_context9.sent) {
              _context9.next = 44;
              break;
            }

            importedObjectCount++;

          case 44:
            _context9.next = 49;
            break;

          case 46:
            _context9.prev = 46;
            _context9.t2 = _context9["catch"](39);

            if (_context9.t2.constructor.name === 'SavedObjectNotFound') {
              if (_context9.t2.savedObjectType === 'index-pattern') {
                conflictedIndexPatterns.push({
                  obj: obj,
                  doc: searchDoc
                });
              } else {
                conflictedSearchDocs.push(searchDoc);
              }
            } else {
              failedImports.push({
                obj: obj,
                error: _context9.t2
              });
            }

          case 49:
            _context9.next = 34;
            break;

          case 51:
            _context9.next = 56;
            break;

          case 53:
            _context9.prev = 53;
            _context9.t3 = _context9["catch"](32);

            _iterator5.e(_context9.t3);

          case 56:
            _context9.prev = 56;

            _iterator5.f();

            return _context9.finish(56);

          case 59:
            _iterator6 = _createForOfIteratorHelper(docTypes.other);
            _context9.prev = 60;

            _iterator6.s();

          case 62:
            if ((_step6 = _iterator6.n()).done) {
              _context9.next = 80;
              break;
            }

            otherDoc = _step6.value;
            _context9.next = 66;
            return getSavedObject(otherDoc, services);

          case 66:
            _obj = _context9.sent;
            _context9.prev = 67;
            _context9.next = 70;
            return importDocument(_obj, otherDoc, overwriteAll);

          case 70:
            if (!_context9.sent) {
              _context9.next = 72;
              break;
            }

            importedObjectCount++;

          case 72:
            _context9.next = 78;
            break;

          case 74:
            _context9.prev = 74;
            _context9.t4 = _context9["catch"](67);
            isIndexPatternNotFound = _context9.t4.constructor.name === 'SavedObjectNotFound' && _context9.t4.savedObjectType === 'index-pattern';

            if (isIndexPatternNotFound && _obj.savedSearchId) {
              conflictedSavedObjectsLinkedToSavedSearches.push(_obj);
            } else if (isIndexPatternNotFound) {
              conflictedIndexPatterns.push({
                obj: _obj,
                doc: otherDoc
              });
            } else {
              failedImports.push({
                obj: _obj,
                error: _context9.t4
              });
            }

          case 78:
            _context9.next = 62;
            break;

          case 80:
            _context9.next = 85;
            break;

          case 82:
            _context9.prev = 82;
            _context9.t5 = _context9["catch"](60);

            _iterator6.e(_context9.t5);

          case 85:
            _context9.prev = 85;

            _iterator6.f();

            return _context9.finish(85);

          case 88:
            return _context9.abrupt("return", {
              conflictedIndexPatterns: conflictedIndexPatterns,
              conflictedSavedObjectsLinkedToSavedSearches: conflictedSavedObjectsLinkedToSavedSearches,
              conflictedSearchDocs: conflictedSearchDocs,
              importedObjectCount: importedObjectCount,
              failedImports: failedImports
            });

          case 89:
          case "end":
            return _context9.stop();
        }
      }
    }, _callee8, null, [[4, 22, 25, 28], [8, 15], [32, 53, 56, 59], [39, 46], [60, 82, 85, 88], [67, 74]]);
  }));
  return _resolveSavedObjects.apply(this, arguments);
}