function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/*
 * Licensed to Elasticsearch B.V. under one or more contributor
 * license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright
 * ownership. Elasticsearch B.V. licenses this file to you under
 * the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
// @ts-ignore
import { uiToReactComponent } from '../../../kibana_react/public';

/**
 * @internal
 */
export var ActionInternal = /*#__PURE__*/function () {
  function ActionInternal(definition) {
    _classCallCheck(this, ActionInternal);

    this.definition = definition;

    _defineProperty(this, "id", this.definition.id);

    _defineProperty(this, "type", this.definition.type || '');

    _defineProperty(this, "order", this.definition.order || 0);

    _defineProperty(this, "MenuItem", this.definition.MenuItem);

    _defineProperty(this, "ReactMenuItem", this.MenuItem ? uiToReactComponent(this.MenuItem) : undefined);
  }

  _createClass(ActionInternal, [{
    key: "execute",
    value: function execute(context) {
      return this.definition.execute(context);
    }
  }, {
    key: "getIconType",
    value: function getIconType(context) {
      if (!this.definition.getIconType) return undefined;
      return this.definition.getIconType(context);
    }
  }, {
    key: "getDisplayName",
    value: function getDisplayName(context) {
      if (!this.definition.getDisplayName) return "Action: ".concat(this.id);
      return this.definition.getDisplayName(context);
    }
  }, {
    key: "getDisplayNameTooltip",
    value: function getDisplayNameTooltip(context) {
      if (!this.definition.getDisplayNameTooltip) return '';
      return this.definition.getDisplayNameTooltip(context);
    }
  }, {
    key: "isCompatible",
    value: function () {
      var _isCompatible = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(context) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (this.definition.isCompatible) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt("return", true);

              case 2:
                _context.next = 4;
                return this.definition.isCompatible(context);

              case 4:
                return _context.abrupt("return", _context.sent);

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function isCompatible(_x) {
        return _isCompatible.apply(this, arguments);
      }

      return isCompatible;
    }()
  }, {
    key: "getHref",
    value: function () {
      var _getHref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(context) {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (this.definition.getHref) {
                  _context2.next = 2;
                  break;
                }

                return _context2.abrupt("return", undefined);

              case 2:
                _context2.next = 4;
                return this.definition.getHref(context);

              case 4:
                return _context2.abrupt("return", _context2.sent);

              case 5:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function getHref(_x2) {
        return _getHref.apply(this, arguments);
      }

      return getHref;
    }()
  }]);

  return ActionInternal;
}();